﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Cci;

namespace AndersLiu.Reflector.Program
{
    /// <summary>
    /// Provides data for the StatusChanged event.
    /// </summary>
    class WorkspaceChangedEventArgs : EventArgs
    {
        /// <summary>
        /// Get a value, indicates why the workspace status changed.
        /// </summary>
        public WorkspaceChangedReason Reason { get; private set; }

        /// <summary>
        /// Get the associated unit.
        /// </summary>
        public WorkspaceUnit Unit { get; private set; }

        /// <summary>
        /// Create a new event args.
        /// </summary>
        /// <param name="reason">Reason.</param>
        /// <param name="unit">Associated unit.</param>
        internal WorkspaceChangedEventArgs(WorkspaceChangedReason reason, WorkspaceUnit unit)
        {
            this.Reason = reason;
            this.Unit = unit;
        }
    }
}
