﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Cci;

namespace AndersLiu.Reflector.Program
{
    /// <summary>
    /// Indicates a unit (assembly or module) in a workspace.
    /// </summary>
    class WorkspaceUnit
    {
        /// <summary>
        /// Create a new workspace unit.
        /// </summary>
        /// <param name="location">Location of the unit.</param>
        internal WorkspaceUnit(string location)
        {
            if (location == null)
                throw new ArgumentNullException("location");

            this.Location = location;
        }

        /// <summary>
        /// Get the location of the unit.
        /// </summary>
        internal string Location { get; private set; }

        internal bool IsAdded { get; set; }
    }
}
